# system.dictionaries

Содержит информацию о внешних словарях.

Столбцы:

```text
name String                   - имя словаря
type String                   - тип словаря: Flat, Hashed, Cache
origin String                 - путь к конфигурационному файлу, в котором описан словарь
attribute.names Array(String) - массив имён атрибутов, предоставляемых словарём
attribute.types Array(String) - соответствующий массив типов атрибутов, предоставляемых словарём
has_hierarchy UInt8           - является ли словарь иерархическим
bytes_allocated UInt64        - количество оперативной памяти, которое использует словарь
hit_rate Float64              - для cache-словарей - доля использований, для которых значение было в кэше
element_count UInt64          - количество хранящихся в словаре элементов
load_factor Float64           - доля заполненности словаря (для hashed словаря - доля заполнения хэш-таблицы)
creation_time DateTime        - время создания или последней успешной перезагрузки словаря
last_exception String         - текст ошибки, возникшей при создании или перезагрузке словаря, если словарь не удалось создать
source String                 - текст, описывающий источник данных для словаря
```

Заметим, что количество оперативной памяти, которое использует словарь, не является пропорциональным количеству элементов, хранящихся в словаре. Так, для flat и cached словарей, все ячейки памяти выделяются заранее, независимо от реальной заполненности словаря.
